# Grunt Mode


## How to Use

**In Attrition gamemode, use the playlistvar** `aitdm_grunt_mode 1` **to replace Attrition with GruntMode**

**Please add** 

- `sv_max_props_multiplayer 500000` 
- `sv_max_prop_data_dwords_multiplayer 800000` 

**to startup args(add an extra **`+`** as prefix) or typing them in console before starting, otherwise the game might crash**


## NOTE

This is a whole mod pack, might cause issue when use together with some other mods or in other gamemodes, recommand run on dedicated servers!

If you're not on dedicated servers, please enable `sv_cheats` and do `weapon_reparse` in console before starting the gamemode, disable `sv_cheats` after `weapon_reparse` is done


## Introduction


**Basic Gameplay:**

- You will respawn as a random class from droppod
- Your double jump and wallrun is disabled by default( some classes may enable them ), but you can still climb walls
- Enemy npcs are stronger


**Score Events:**

Start with player grunts and normal grunts

- 0: Specialist grunts spawning

- 50: Spectres spawning

- 100: Stalkers and Prowlers spawning

- 180: Reapers and Gunships

- 250: Titans and NPC pilots spawning


**Playlist Variable Settings**

- Each game has a 33% chance of becoming a night combat( chance can be modified through playlistvar `gruntmode_night_chance` )
- Map instantly change after game( can be turned off through playlistvar `gruntmode_auto_map 0` )
- Taking damage from titans and explosions(such as nuke and ticks) will leave you 1HP( protection can be turned off through playlistvar `grunt_player_protection 0` )
- Your abilities and ordnances won't recharge by default( some classes may have regenable abilities ), search for care packages to refill them and your anti-titan weapon's ammo. When playlistvar `gruntmode_weapon_carepackage 1` is enabled, care package will also give you a grenadier weapon
- You can use `custom_air_accel_pilot` to customize player's air acceleration if you want to disable their ability to slidehop
- Add **Classic Rodeo Fix**(Testing): Use the playlist var `classic_rodeo 1` to enable (fake) TF|1 style rodeo. Rodeo damage can be modified through playlistvar `classic_rodeo_damage_scale`


**Default Player Classes:**

- Assault Grunt:        r97, archer and frag grenade

- Heavy Grunt:          spitfire and archer

- Rifleman Grunt:       flatline, archer and frag grenade

- Shotgun Grunt:        eva-8, archer and frag grenade

- Sniper Grunt:         dmr, archer and electric smoke grenade

- Engineer:		        l-star and thunderbolt, one turret in inventory

- Specialist Grunt:     l-star and mgl, can deploy two drones

- Shield Captain:       r201 and mgl, carrying a mobile particle wall

- Shock Grunt:			volt and thunderbolt, one arc trap in inventory

- Spectre:				mastiff and charge rifle, have double jump ability

- Sonar Pulser:         alternator, charge rifle and pulse blade

- Jumper:               devotion and mgl, one jumppad usage

- Shifter:              double-take and thunderbolt, one longer phaseshift usage

- Ravenant:			    hemlok, charge rifle and satchel, super wallclimb, faster crouchwalk

- Phase Walker:         r101 and thunderbolt, one portal usage(portal destroys on death)

- Heavy Sniper:         kraber(anti-titan) and electric smoke grenade

- Runner:			    re45 and mgl, octane stim(longer stim that costs health)

- Path Builder:         r97 and mgl, one zipline gun usage(zipline destroys on death)

- Scout:                g2 and archer, two grapple usage

- Flyer:                mozambique and charge rifle, passive jet pack

- Assassin:             wingman elite, charge rifle and arc grenade


## Modding Feature

Use the function `GruntMode_RegisterPlayerClass( string className, void functionref( entity ) classLoadoutFunction, bool isSpecialist )` to register your own classes

Parameters:

- className: your new class' name, cannot be the same as any other classes

- loadoutFunction: how this class is given weapons, classMods and so on

- isSpecialist: whether killing this class will get extra scores

I recommand copy & paste and use the function `SimpleClassLoadout()` from `_grunt_default_classes.gnut`, you can also learn how to create a class from this file


## Special Thanks

I used/modified some scripts from following mods

Thanks to them giving me a chance to add more stuff into my mod!

[Dinorush](https://github.com/Dinorush): Brute4

[Moblin](https://github.com/GalacticMoblin): Archon

[The PeePeePooPoo Man](https://github.com/JMM889901): Flipside and Mutator Pack

[uniboi](https://github.com/uniboi): Impulse Grenade and Holosprays

[Palomar](https://github.com/Palomar-7478): Phaseshift Rework

[Legonzaur](https://github.com/Legonzaur): Holoshift


### Change Logs

**v3.2.0**

- Update Readme

- Make npc Vanguard-Class titan's health bar visible

- Fix npcs targeting embarking npc pilots

- Fix npc friendly highlights

- Merge gunship spawn into reaper score event

- Fix npc pilot's incorrect weapon damage

- Add more weapons for npc pilot

- Fix npc Vanguard-Class titan's rodeo sound

- Add compatibility with Northstar v1.19.10


**v3.1.11**

- Add better npc pilot ejecting behavior, reduce the chance they get stuck in rooftop or somewhere


**v3.1.10**

- Make reaper unable to melee rodeo player when they're targeting the titan

- Add attachments for npc weapons


**v3.1.9**

- Add NPC Gunship spawn

- Add compatibility with Northstar v1.19.9


**v3.1.8**

- Update Readme


**v3.1.7**

- Update Special Thanks

- Add back compatibility with PR#655

- Make infantry with AT weapon don't running around when titan getting close

- Remove npc specialist grunt spawn with stalkers

- Balance npc specialist grunt weapons( buff elite-guard grunts and nerf sniper grunts )

- Balance stalker weapons( buff epg, softball and nerf smr )

- Increase the damage prowlers dealt to titans and reapers

- Add dangerous area for npc titan( excluded player owned titans ) and reaper's drop spot

- Make npcs don't target npc titans( excluded player owned titans ) in bubble shield

- Make npc titan unable to melee rodeo player when they're targeting the titan


**v3.1.6**

- Fix incorrect kill replay callsign display when killed by a npc

- Fix a crash that may happen during intro spawn


**v3.1.5**

- Add compatibility with following update: [PR#701](https://github.com/R2Northstar/NorthstarMods/pull/701)


**v3.1.4**

- Temporarily remove compatibility with PR#655 to make the mod able to compile at current version

- Fix a client script error related with npc arcball weapons


**v3.1.3**

- Use spawn waves for npc spawn to make it more stable

- Use custom execution chooser for npcs

- Add compatibility with following update: [PR#554](https://github.com/R2Northstar/NorthstarMods/pull/554), [PR#655](https://github.com/R2Northstar/NorthstarMods/pull/655)


**v3.1.2**

- Bug fixes about compilation and client-side runtime error


**v3.1.1**

- Add npc titan rodeo countermeasure( electric smoke )


**v3.1.0**

- Add compatibility with Northstar v1.18.0